package net.t2code.t2callayduplicate.config;

import lombok.Getter;
import net.t2code.t2callayduplicate.system.Main;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Replace;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Send;
import org.bukkit.Material;
import org.bukkit.Particle;
import org.bukkit.Sound;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;
import java.util.Objects;

public class ConfigFile {
    public static void create() {
        File config = new File(Main.getPath(), "config.yml");
        YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(config);
        yamlConfiguration.set("Plugin.Language", "ENGLISH");

        yamlConfiguration.set("Plugin.updateCheck.onJoin",true);
        yamlConfiguration.set("Plugin.updateCheck.seePreReleaseUpdates",true);
        yamlConfiguration.set("Plugin.updateCheck.timeInterval",60);

        yamlConfiguration.set("Duplicate.SneakRequired", true);
        yamlConfiguration.set("Duplicate.Item.Enable", true);
        yamlConfiguration.set("Duplicate.Item.Material", Material.AMETHYST_SHARD.toString());
        yamlConfiguration.set("Duplicate.Item.Amount", 1);

        yamlConfiguration.set("Duplicate.Particle.Enable", true);
        yamlConfiguration.set("Duplicate.Particle.Particle", "HEART");

        yamlConfiguration.set("Duplicate.Sound.Enable", true);
        yamlConfiguration.set("Duplicate.Sound.Sound", "ENTITY_ALLAY_AMBIENT_WITHOUT_ITEM");
        yamlConfiguration.set("Duplicate.Sound.Volume", 3);

        yamlConfiguration.set("Duplicate.Delay.Enable", true);
        yamlConfiguration.set("Duplicate.Delay.ProAllay", false);
        yamlConfiguration.set("Duplicate.Delay.ResetOnReload", true);
        yamlConfiguration.set("Duplicate.Delay.Seconds", 300);

        yamlConfiguration.set("Duplicate.Cost.Enable", true);
        yamlConfiguration.set("Duplicate.Cost.Price", 10.00);

        yamlConfiguration.set("Messages.MiniMessagesEditorLink", "https://webui.adventure.kyori.net");
        yamlConfiguration.set("Messages.Prefix", "<dark_gray>[<dark_red>T2C</dark_red><aqua>Allay</aqua><gold>Duplicate</gold>]</dark_gray>");

        yamlConfiguration.set("Messages.ENGLISH.Plugin.NoPerm", "[prefix] <red>You are not authorized to do that!</red>");
        yamlConfiguration.set("Messages.ENGLISH.Duplicate", "[prefix] <green>Du You have duplicated an allay.</green>");
        yamlConfiguration.set("Messages.ENGLISH.Error.Delay", "[prefix] <red>You have to wait <gold>[min] minutes, [sec] seconds</gold> before you can duplicate the next allay.</red>");
        yamlConfiguration.set("Messages.ENGLISH.Error.IncorrectItem", "[prefix] <red>You need <gold>[amount] [item]</gold> to be able to duplicate an allay.</red>");
        yamlConfiguration.set("Messages.ENGLISH.Error.NoMoney", "[prefix] <red>You need <gold>[price] $</gold> to be able to duplicate an allay.</red>");
        yamlConfiguration.set("Messages.ENGLISH.Error.Reset", "[prefix] <red>Player <gold>[player]</gold> not online!</red>");
        yamlConfiguration.set("Messages.ENGLISH.Error.CanNotBuild", "[prefix] <red>You are not authorized to do so at this area.</red>");
        yamlConfiguration.set("Messages.ENGLISH.Reset", "[prefix] <green>The delay of <gold>[player]</gold> has been reset.</green>");
        yamlConfiguration.set("Messages.ENGLISH.ResetAll", "[prefix] <green>The delay of all players has been reset.</green>");

        yamlConfiguration.set("Messages.GERMAN.Plugin.NoPerm", "[prefix] <red>Dazu bist du nicht berechtigt!</red>");
        yamlConfiguration.set("Messages.GERMAN.Duplicate", "[prefix] <green>Du hast ein Allay verdoppelt.</green>");
        yamlConfiguration.set("Messages.GERMAN.Error.Delay", "[prefix] <red>Du musst noch <gold>[min] Minuten, [sec] Sekunden</gold> warten, befor du das nächste Allay duplizieren kannst.</red>");
        yamlConfiguration.set("Messages.GERMAN.Error.IncorrectItem", "[prefix] <red>Du benötigst <gold>[amount] [item]</gold> um einen Allay duplizieren kannst.</red>");
        yamlConfiguration.set("Messages.GERMAN.Error.NoMoney", "[prefix] <red>Du benötigst <gold>[price] $</gold> um einen Allay duplizieren kannst.</red>");
        yamlConfiguration.set("Messages.GERMAN.Error.Reset", "[prefix] <red>Spieler <gold>[player]</gold> nicht Online!</red>");
        yamlConfiguration.set("Messages.GERMAN.Error.CanNotBuild", "[prefix] <red>Du bist an diesem Bereich nicht dazu berechtigt.</red>");
        yamlConfiguration.set("Messages.GERMAN.Reset", "[prefix] <green>Das Delay von <gold>[player]</gold> wurde zurückgesetzt.</green>");
        yamlConfiguration.set("Messages.GERMAN.ResetAll", "[prefix] <green>Das Delay von allen Spielern wurde zurückgesetzt.</green>");
        try {
            yamlConfiguration.save(config);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void select() {
        File config = new File(Main.getPath(), "config.yml");
        YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(config);
        language = yamlConfiguration.getString("Plugin.Language");
        updateCheckOnJoin = yamlConfiguration.getBoolean("Plugin.updateCheck.onJoin");
        updateCheckSeePreReleaseUpdates = yamlConfiguration.getBoolean("Plugin.updateCheck.seePreReleaseUpdates");
        updateCheckTimeInterval = yamlConfiguration.getInt("Plugin.updateCheck.timeInterval");

        sneakRequired = yamlConfiguration.getBoolean("Duplicate.SneakRequired");
        itemEnable = yamlConfiguration.getBoolean("Duplicate.Item.Enable");
        itemMaterial = yamlConfiguration.getString("Duplicate.Item.Material");
        itemAmount = yamlConfiguration.getInt("Duplicate.Item.Amount");

        particleEnable = yamlConfiguration.getBoolean("Duplicate.Particle.Enable");
        try {
            particleParticle = Particle.valueOf(yamlConfiguration.getString("Duplicate.Particle.Particle"));
        } catch (Exception ex) {
            T2C_Send.error(Main.getPlugin(), "");
            T2C_Send.console(String.format("§4The particle %s does not exist, please check your config. The %s is used as particle.", yamlConfiguration.getString("Duplicate.Particle.Particle"), "HEART"));
            T2C_Send.error(Main.getPlugin(), "");
            particleParticle = Particle.HEART;
        }

        soundEnable = yamlConfiguration.getBoolean("Duplicate.Sound.Enable");
        try {
            soundSound = Sound.valueOf(yamlConfiguration.getString("Duplicate.Sound.Sound"));
        } catch (Exception ex) {
            T2C_Send.error(Main.getPlugin(), "");
            T2C_Send.console(String.format("§4The sound %s does not exist, please check your config. The %s is used as sound.", yamlConfiguration.getString("Duplicate.Sound.Sound"), "ENTITY_ALLAY_AMBIENT_WITHOUT_ITEM"));
            T2C_Send.error(Main.getPlugin(), "");
            soundSound = Sound.ENTITY_ALLAY_AMBIENT_WITHOUT_ITEM;
        }
        soundVolume = yamlConfiguration.getInt("Duplicate.Sound.Volume");

        delayEnable = yamlConfiguration.getBoolean("Duplicate.Delay.Enable");
        delayProAllay = yamlConfiguration.getBoolean("Duplicate.Delay.ProAllay");
        delayResetOnReload = yamlConfiguration.getBoolean("Duplicate.Delay.ResetOnReload");
        delaySeconds = yamlConfiguration.getInt("Duplicate.Delay.Seconds");

        costEnable = yamlConfiguration.getBoolean("Duplicate.Cost.Enable");
        costPrice = yamlConfiguration.getDouble("Duplicate.Cost.Price");

        prefix = yamlConfiguration.getString("Messages.Prefix");

        noPerm = getMSG("Messages." + language + ".Plugin.NoPerm",yamlConfiguration);
        duplicate = getMSG("Messages." + language + ".Duplicate",yamlConfiguration);
        errorDelay = getMSG("Messages." + language + ".Error.Delay",yamlConfiguration);
        errorIncorrectItem = getMSG("Messages." + language + ".Error.IncorrectItem",yamlConfiguration);
        errorNoMoney = getMSG("Messages." + language + ".Error.NoMoney",yamlConfiguration);
        errorReset = getMSG("Messages." + language + ".Error.Reset",yamlConfiguration);
        errorCanNotBuild = getMSG("Messages." + language + ".Error.CanNotBuild",yamlConfiguration);
        reset = getMSG("Messages." + language + ".Reset",yamlConfiguration);
        ResetAll = getMSG("Messages." + language + ".ResetAll",yamlConfiguration);


    }

    @Getter
    private static String language;


    @Getter
    private static Boolean updateCheckOnJoin;
    @Getter
    private static Boolean updateCheckSeePreReleaseUpdates;
    @Getter
    private static Integer updateCheckTimeInterval;
    @Getter
    private static Boolean sneakRequired;
    @Getter
    private static Boolean itemEnable;
    @Getter
    private static String itemMaterial;
    @Getter
    private static Integer itemAmount;

    @Getter
    private static Boolean particleEnable;
    @Getter
    private static Particle particleParticle;

    @Getter
    private static Boolean soundEnable;
    @Getter
    private static Sound soundSound;
    @Getter
    private static Integer soundVolume;

    @Getter
    private static Boolean delayEnable;
    @Getter
    private static Boolean delayProAllay;
    @Getter
    private static Boolean delayResetOnReload;
    @Getter
    private static Integer delaySeconds;

    @Getter
    private static Boolean costEnable;
    @Getter
    private static Double costPrice;

    @Getter
    private static String prefix;
    @Getter
    private static String noPerm;
    @Getter
    private static String duplicate;
    @Getter
    private static String errorDelay;
    @Getter
    private static String errorIncorrectItem;
    @Getter
    private static String errorNoMoney;
    @Getter
    private static String errorReset;
    @Getter
    private static String errorCanNotBuild;
    @Getter
    private static String reset;
    @Getter
    private static String ResetAll;

    private static String getMSG(String path, YamlConfiguration yamlConfiguration) {
        String out;
        if (yamlConfiguration.get(path) != null) {
            out = T2C_Replace.replace(prefix, Objects.requireNonNull(yamlConfiguration.getString(path)));
        } else {
            T2C_Send.error(Main.getPlugin(), String.format("The message on the path [%s] was not found. Please check if the language [%s] exists.", path, language));
            out = path;
        }
        return out;
    }

}
